<template>
  <div>
    <article>
      <h1>Текущие курсы</h1>
      <ul>
        <rate
          component="li"
          v-for="rateEntry in currentRates"
          :key="rateEntry.id"
          :rate="rateEntry"
        />
      </ul>
    </article>
    <article>
      <h1>Исторический курс</h1>
      <label>
        Дата:
        <input type="date" v-model="date" />
      </label>
      <label>
        Базовая валюта:
        <select v-model="baseCurrency">
          <option disabled value>Выбрать...</option>
          <option v-for="currency in availableCurrencies" :key="currency">{{ currency }}</option>
        </select>
      </label>
      <label>
        Целевая валюта:
        <select v-model="currency">
          <option disabled value>Выбрать...</option>
          <option v-for="currency in availableCurrencies" :key="currency">{{ currency }}</option>
        </select>
      </label>
      <div v-if="historicalRate">
        <rate :rate="historicalRate" />
      </div>
    </article>
  </div>
</template>

<script>
import currentRatesQuery from "./graphql/currentRatesQuery.gql";
import historicalRateQuery from "./graphql/historicalRateQuery.gql";
import Rate from "./components/Rate.vue";

export default {
  name: "app",
  components: {
    Rate
  },
  apollo: {
    currentRates: currentRatesQuery,
    historicalRate: {
      query: historicalRateQuery,
      variables() {
        return {
          baseCurrency: this.baseCurrency,
          currency: this.currency,
          date: this.date
        };
      },
      skip() {
        return !this.baseCurrency || !this.currency || !this.date;
      }
    }
  },
  data() {
    return {
      currentRates: [],
      historicalRate: null,
      baseCurrency: "",
      currency: "",
      date: "2010-01-01"
    };
  },

  computed: {
    availableCurrencies() {
      return this.currentRates.map(({ currency }) => currency);
    }
  }
};
</script>

<style>
ul {
  padding: 0;
  list-style: none;
  display: flex;
  flex-wrap: wrap;
}

h1 {
  font-size: 2em;
}
</style>
